/*

    Regras de inclusão de recursos e eventos

    1 - a lista deve conter pelo menos um recurso ou evento do tipo selecionado no campo tipo no cabeçalho!
    2 - (Eventos, salas e Veícols) para estes tipos é permitido a inclussão de 1 de cada
    3 - a inclussão de equipamentos é ilimitada
    4 - pelo menos deve haver um recurso ou evento vinculado.


*/

var xTudoCerto = true;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function validaRecursoEvento(){
    var tbodyElement = document.getElementById('recursoContainer');
    var selectElements = tbodyElement.querySelectorAll('.tacre_cta_id');

    tudoCerto = true;

    count1 = 0;
    count2 = 0;
    count4 = 0;

    selectElements.forEach((select) => {
        if (select.value === '1') { count1++; }
        if (select.value === '2') { count2++; }
        if (select.value === '4') { count4++; }
    });

    if(count1 > 1){ tudoCerto = false; alert('Violação! A tabela de recursos e eventos possue o limite de 1 Sala!'); }
    if(count2 > 1){ tudoCerto = false; alert('Violação! A tabela de recursos e eventos possue o limite de 1 Veículo!'); }
    if(count4 > 1){ tudoCerto = false; alert('Violação! A tabela de recursos e eventos possue o limite de 1 Evento!'); }

    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if(selectElements.length == 0){ tudoCerto = false; alert('Violação! É necessario incluir um ou mais recursos no agendamento!'); }

    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    elementsWithClass = document.querySelectorAll('.tacre_cre_descricao');

    // Itere sobre os elementos e verifique se estão vazios
    elementsWithClass.forEach(element => {
        if (element.value.trim() === '') {
            tudoCerto = false; alert('Violação! Existem itens na tabela de Recursos e Eventos sem descrição!');
            element.classList.add('borda-vermelha');
        } else {
            // Remova a classe CSS de borda vermelha se o elemento não estiver vazio
            element.classList.remove('borda-vermelha');
        }
    });

    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    var cta_id = $('#cta_id').val();

    var cta_idEncontrado = 'N';

    if (tbodyElement) {
        var rows = tbodyElement.getElementsByTagName('tr'); // Obtenha todas as linhas dentro do tbody

        for (var i = 0; i < rows.length; i++) {
            var row = rows[i];

            // Verifique se o select de classe .tacre_cta_id tem a opção com value 4 selecionada
            var selectElement = row.querySelector('.tacre_cta_id');
            if (selectElement && selectElement.value === cta_id) {

                cta_idEncontrado = 'S';

                // Verifique se o input de tipo radio está marcado
                var radioElement = row.querySelector('input[type="radio"]');
                radioElement.checked = true;
            }
        }
    }

    if(cta_idEncontrado == 'N'){
        tudoCerto = false; alert('Violação! É necessário incluir um recurso ou evento do mesmo tipo do agendamento!');
    }


    return tudoCerto;

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function validacaorecursoEventoOnBackEnd(callback){
    var tbodyElement = document.getElementById('recursoContainer');
    if (tbodyElement) {
        var rows = tbodyElement.getElementsByTagName('tr');
        var jsonData = [];

        for (let i = 0; i < rows.length; i++) {
            var row = rows[i];
            var inputs = row.querySelectorAll('input');
            var selects = row.querySelectorAll('select');

            var rowData = {};

            inputs.forEach(input => {
                var column = input.getAttribute('column');
                var value = input.value;

                if (input.type === 'radio') {
                    // Para campos de tipo radio, use true/false em vez de valores
                    rowData[column] = input.checked;
                } else {
                    rowData[column] = value;
                }
            });

            selects.forEach(select => {
                var column = select.getAttribute('column');
                var value = select.value;
                rowData[column] = value;
            });

            jsonData.push(rowData);
        }

        var jsonTabRecursos = JSON.stringify(jsonData, null, 2);
        console.log(jsonTabRecursos);
        $('#tab_agenda_x_cad_recurso_evento').val(jsonTabRecursos);
    }

    var encodedJson = encodeURIComponent(jsonTabRecursos);

    var http = new XMLHttpRequest();
    var url = "../gethint/gethint.php";
    var params = 'xml=<request><tipo>validacaorecursoEventoOnBackEnd</tipo><json>' + encodedJson  + '</json></request>';
    http.open("POST", url, true);

    //Send the proper header information along with the request
    http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            
    http.onreadystatechange = function() {//Call a function when the state changes.
        if(http.readyState == 4 && http.status == 200) { 
            retorno = http.responseText;
            
            jsonObject = JSON.parse(retorno);

            if (jsonObject[0].erro == 'S') {
                callback(true);
            } else {
                callback(false);
            }
        }
    }
    http.send(params);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function verificaVeiculoRota(){
    setTimeout(function() {
        var tbodyElement = document.getElementById('recursoContainer');
        var selectElements = tbodyElement.querySelectorAll('.tacre_cta_id');

        count2 = 0;

        selectElements.forEach((select) => {
            if (select.value == '2') { count2++; }
        });

        if(count2 > 0){
            $('.divRota').show();
        }else{
            $('.divRota').hide();
        }
    }, 250);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var addRecursoEventoAUX = 0

function addRecursoEvento(){
    addRecursoEventoAUX = addRecursoEventoAUX + 1;
    var cta_idOPT =  listaTiposSelecionados();

    tbodyElement = document.getElementById('recursoContainer');
    rowCount = tbodyElement.getElementsByTagName('tr').length;

    if(rowCount == 0) {checked = 'checked'}else{checked = '';}

    el = '  <tr id="id_RecursoEvento' + addRecursoEventoAUX + '">' + 
                '<td style=" text-align: center; vertical-align: middle !important;">' + 
                    '<img    src="../_img/1810747.png" ' + 
                            'title="Excluir este recurso ou evento desta lista!" ' + 
                            'width="22" ' + 
                            'height="22" ' + 
                            'onclick="deletaRecursoEvento(' + addRecursoEventoAUX + ')">' + 
                '</td>' + 
                '<td>' + 
                    '<select    class="fullInputEmbalagem ' + 
                                'tacre_cta_id" ' + 
                                'onchange="verificaVeiculoRota()"' +
                                'id="tacre_cta_id' + addRecursoEventoAUX + '"' + 
                                'column="tacre_cta_id">' + 
                            cta_idOPT + 
                    '</select>' + 
                '</td>' + 
                '<td>Cadastrado</td>' + 
                '<input type="hidden" column="tacre_volatil" value="N">' + 
                '<td>' + 
                    '<input  type="text" ' + 
                            'class="fullInputEmbalagem cursorPointer tacre_cre_descricao" ' + 
                            'readonly ' + 
                            'column="tacre_cre_descricao"' + 
                            'id="tacre_cre_descricao' + addRecursoEventoAUX + '"' +
                            'onclick="abreTelaRecursoEvento(' + addRecursoEventoAUX + ')" ' +
                            'placeholder="Selecione um Recurso ou Evento...">' + 
                    '<input  type="hidden"' +
                            'id="tacre_cre_id' + addRecursoEventoAUX + '"' +
                            'class="tacre_cre_id"' +
                            'column="tacre_cre_id"' +
                            'value="0">' +
                '</td>' + 
                '<td style=" text-align: center; vertical-align: middle !important;">' + 
                    '<input  type="radio"' + checked + ' ' +
                            'style="height: 20px; width: 20px;"' + 
                            'column="tacre_principal"' +
                            'name="recursoPrincipal"' + 
                            'value="2">' + 
                '</td>' + 
            '</tr>';

    $('#recursoContainer').append(el); 
    verificaVeiculoRota();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function addRecursoEventoVolatil(){
    addRecursoEventoAUX = addRecursoEventoAUX + 1; 
    var cta_idOPT =  listaTiposSelecionados();

    tbodyElement = document.getElementById('recursoContainer');
    rowCount = tbodyElement.getElementsByTagName('tr').length;

    if(rowCount == 0) {checked = 'checked'}else{checked = '';}

    el = '<tr id="id_RecursoEvento' + addRecursoEventoAUX + '">' + 
        '<td style=" text-align: center; vertical-align: middle !important;">' + 
            '<img    src="../_img/1810747.png" ' + 
                    'title="Excluir este recurso ou evento desta lista!" ' + 
                    'width="22" ' + 
                    'height="22" ' + 
                    'onclick="deletaRecursoEvento(' + addRecursoEventoAUX + ')">' + 
        '</td>' + 
        '<td>' + 
        '<select    class="fullInputEmbalagem ' + 
                                'tacre_cta_id" ' + 
                                'onchange="verificaVeiculoRota()"' +
                                'id="tacre_cta_id' + addRecursoEventoAUX + '"' + 
                                'column="tacre_cta_id">' + 
                            cta_idOPT + 
                    '</select>' + 
        '</td>' + 
        '<td>Volátil</td>' + 
        '<input type="hidden" column="tacre_volatil" value="S">' + 
        '<td>' + 
            '<input  type="text" ' + 
                    'class="fullInputEmbalagem tacre_cre_descricao" ' + 
                    'column="tacre_cre_descricao"' + 
                    'placeholder="Insira a descição do item volátil...">' + 
            '<input  type="hidden"' +
                    'id="tacre_cre_id' + addRecursoEventoAUX + '"' +
                    'column="tacre_cre_id"' +
                    'value="0">' +
        '</td>' + 
        '<td style=" text-align: center; vertical-align: middle !important;">' + 
            '<input  type="radio"' +  checked +  ' ' +
                    'style="height: 20px; width: 20px;"' + 
                    'column="tacre_principal"' +
                    'name="recursoPrincipal"' + 
                    'value="2">' + 
        '</td>' + 
    '</tr>';

    $('#recursoContainer').append(el);
    verificaVeiculoRota();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function listaTiposSelecionados(){

   /* optTipo = '';

    //coletar tipos ja selecionados
    const selectElements = document.querySelectorAll('.tacre_cta_id');
    const valuesInTableArray = [];
    selectElements.forEach((select) => {
        valuesInTableArray.push(select.value);
    });
    

    //coletar tipos permitidos
    const selectElement = document.getElementById('cta_id');
    const valuesPermitidosArray = [];
    
    for (let i = 0; i < selectElement.options.length; i++) {
        valuesPermitidosArray.push(selectElement.options[i].value);
    }

    if(valuesPermitidosArray.includes('3')){
        optTipo += '<option value="3">Equipamento</option>';
    }

    valuesPermitidosArray.forEach(value => {
        if (value != '3') {
            if(!valuesInTableArray.includes(value)){
                if (value == '1'){optTipo += '<option value="1">Sala</option>';}
                if (value == '2'){optTipo += '<option value="2">Veículo</option>';}
                if (value == '4'){optTipo += '<option value="4">Evento</option>';}
            }
        }
    });
    
    return optTipo;*/

    var selectElement = document.getElementById("cta_id");

    // Inicializa uma string vazia para armazenar as opções
    var optionsString = "";

    // Itera sobre as opções dentro do elemento <select>
    for (var i = 0; i < selectElement.options.length; i++) {
        // Verifica se a opção está selecionada
        var isSelected = selectElement.options[i].selected;
        
        // Obtém o valor e o texto de cada opção e adiciona-os à string
        optionsString += "<option value='" + selectElement.options[i].value + "'";
        
        // Se a opção estiver selecionada, adicione o atributo 'selected'
        if (isSelected) {
            optionsString += " selected";
        }
        
        optionsString += ">" + selectElement.options[i].text + "</option>";
    }
    return optionsString;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function abreTelaRecursoEvento(id){

    cre_id = "";

    elementsWithClass = document.querySelectorAll('.tacre_cre_id');
    filteredElements = Array.from(elementsWithClass).filter(element => element.id !== 'tacre_cre_id' + id);
    tacre_cre_idArray = [];
    if(filteredElements.length > 0){
        filteredElements.forEach(element => {
            tacre_cre_idArray.push(element.value);
        });
        tacre_cre_idValueString = tacre_cre_idArray.join(',');

        cre_id = " and cre_id not in (" + tacre_cre_idValueString + ")";
    }

    tacre_cta_id = document.getElementById('tacre_cta_id' + id).value;

    var json_id_codigo_fiscal = [{
        "titulo": "Lista de Recursos e Eventos",
        "tabela": "view_cad_grupo_recurso_evento_x_cad_recurso_evento2",
        "filtro": "cre_cta_id = " + tacre_cta_id + cre_id + " and cgrecre_cgre_id in ( " + cad_perfil_usuario_x_cad_grupo_recurso_evento + " )",
        "order": "cre_descricao",
        "cod_select": "",
        "desc_select": "cre_descricao",
        "value_select": "cre_id",
        "id_input_desc": "tacre_cre_descricao",
        "id_input_value": "tacre_cre_id",
        "colunas": [
            {"coluna": "cre_descricao", "titulo": "Descrição", "tipo": "texto"}
        ] 
    }];
    abreTela(json_id_codigo_fiscal, id);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function deletaRecursoEvento(id){
    confirma = confirm('Confirma a exclusão deste recurso do agendamento?');
    if(confirma){$('#id_RecursoEvento' + id).remove();}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function deletaPeriodoAgendamento(id){
    confirma = confirm('Confirma a exclusão deste Período de Agendamento?');
    if(confirma){$('#tab_agenda_periodo_agendamento' + id).remove(); verificaConflitoPeriodosAgendamento();}
}

var tab_agenda_periodo_agendamento = 0;

function addPeriodoAgendamento(){
    tab_agenda_periodo_agendamento = tab_agenda_periodo_agendamento + 1;
    el = '  <tr id="tab_agenda_periodo_agendamento' + tab_agenda_periodo_agendamento + '">' +
                '<td style=" text-align: center; vertical-align: middle !important;">' +
                    '<img   src="../_img/1810747.png"' +
                            'title="Excluir este Período de Agendamento!"' +
                            'width="22"' +
                            'height="22"' +
                            'onclick="deletaPeriodoAgendamento(' + tab_agenda_periodo_agendamento + ')">' +
                '</td>' +
                '<td>' +
                    '<input type="datetime-local"' +
                            'class="fullInputEmbalagem capa_data_inicio" ' + 
                            'column="capa_data_inicio">' +
                '</td>' +
                '<td>' +
                    '<input type="datetime-local"' +
                            'class="fullInputEmbalagem capa_data_fim" ' +
                            'column="capa_data_fim">' +
                '</td>' +
                '<td class="capa_duracao" style="text-align: center;"></td>' +
            '</tr>';
    
    $('#periodoAgendamentoContainer').append(el);
}

var periodoAgendamentoContainer = document.getElementById('periodoAgendamentoContainer');

if (periodoAgendamentoContainer) {
    periodoAgendamentoContainer.addEventListener('change', function (event) {
        var target = event.target;

        if (target.tagName === 'INPUT' && target.type === 'datetime-local') {
            // Encontrou um campo de data alterado, calcula o intervalo
            var row = target.closest('tr');
            var dateInputs = row.querySelectorAll('input[type="datetime-local"]');
            var durationCell = row.querySelector('.capa_duracao');

            if (dateInputs.length === 2 && durationCell) {
                var startDate = new Date(dateInputs[0].value);
                var endDate = new Date(dateInputs[1].value);

                if (!isNaN(startDate) && !isNaN(endDate)) {

                    if (startDate > endDate) {
                        // Caso a data de início seja maior que a data de fim, aplicar a borda vermelha
                        dateInputs[0].style.border = '1px solid red';
                        dateInputs[1].style.border = '1px solid red';
                    } else {
                        // Caso contrário, remover a borda vermelha
                        dateInputs[0].style.border = '1px solid transparent';
                        dateInputs[1].style.border = '1px solid transparent';
                    }

                    var timeDiff = Math.abs(endDate.getTime() - startDate.getTime());
                    var days = Math.floor(timeDiff / (1000 * 60 * 60 * 24));
                    var hours = Math.floor((timeDiff % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
                    var minutes = Math.floor((timeDiff % (1000 * 60 * 60)) / (1000 * 60));

                    var duration = '';

                    if (days > 0) {
                        duration += days + ' dias ';
                    }

                    if (hours > 0) {
                        duration += hours + ' hrs ';
                    }

                    if (minutes > 0) {
                        duration += minutes + ' min.';
                    }


                    //var duration = hours + ' hrs ' + minutes + ' min.';
                    durationCell.textContent = duration;
                }
            }
        }
        verificaConflitoPeriodosAgendamento();
    });

    
}

function verificaConflitoPeriodosAgendamento(){

    var periodTable = document.getElementById('periodoAgendamentoContainer');
    var rows = periodTable.getElementsByTagName('tr');

    //capa_data_inicio,capa_data_fim

    for (var i = 0; i < rows.length; i++) {
        var currentRow = rows[i];
        var startDateInput = currentRow.querySelector('.capa_data_inicio');
        var endDateInput = currentRow.querySelector('.capa_data_fim');

        // Converter os valores das datas em objetos Date
        var startDate = new Date(startDateInput.value);
        var endDate = new Date(endDateInput.value);

        for (var j = 0; j < rows.length; j++) {
            if (i !== j) {
                var otherRow = rows[j];
                var otherStartDateInput = otherRow.querySelector('.capa_data_inicio');
                var otherEndDateInput = otherRow.querySelector('.capa_data_fim');

                startDateInput.style.border = '0px solid red';
                endDateInput.style.border = '0px solid red';
                otherStartDateInput.style.border = '0px solid red';
                otherEndDateInput.style.border = '0px solid red';

                // Converter os valores das datas da outra linha em objetos Date
                var otherStartDate = new Date(otherStartDateInput.value);
                var otherEndDate = new Date(otherEndDateInput.value);

                // Verificar se há conflito
                if (
                    (startDate >= otherStartDate && startDate < otherEndDate) ||
                    (endDate > otherStartDate && endDate <= otherEndDate) ||
                    (startDate <= otherStartDate && endDate >= otherEndDate)
                ) { 
                    // Há um conflito entre os períodos
                    startDateInput.style.border = '1px solid red';
                    endDateInput.style.border = '1px solid red';
                    otherStartDateInput.style.border = '1px solid red';
                    otherEndDateInput.style.border = '1px solid red';
                }
            }
        }
    }
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function deletaConvidado(id){
    confirma = confirm('Confirma a exclusão deste Convidado?');
    if(confirma){$('#tacu_id' + id).remove();}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function abreTelaConvidado(id){

    var tbodyElement = document.getElementById('convidadoContainer');
    var rows = tbodyElement.getElementsByTagName('tr');

    var valoresTACUCusID = [];

    for (var i = 0; i < rows.length; i++) {
        var row = rows[i];

        var rowId = row.id;

        if (rowId !== 'tacu_id' + id) {
            var inputVolatil = row.querySelector('.tacu_volatil');
        
            if (inputVolatil.value === 'N') {
                var inputCusID = row.querySelector('.tacu_cus_id');
                valoresTACUCusID.push(inputCusID.value);
            }
        }
    }

    var resultado = valoresTACUCusID.join(',');

    var where = '';

    if(resultado != ''){
        where = " and cus_id not in (" + resultado + ") ";
    }
    

    var json_convidados = [{
        "titulo": "Lista de Convidados",
        "tabela": "view_cad_usuario_convidados",
        "filtro": "cus_id != " + cus_id + where,
        "order": "cus_nome",
        "cod_select": "",
        "desc_select": "cus_nome",
        "value_select": "cus_id",
        "id_input_desc": "tacu_convidado",
        "id_input_value": "tacu_cus_id",
        "function":"verificaMail",
        "colunas": [
            {"coluna": "cus_nome", "titulo": "Convidado", "tipo": "texto"},
            {"coluna": "cus_email", "titulo": "E-mail", "tipo": "texto"}
        ] 
    }];
    abreTela(json_convidados, id);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function verificaMail(id){
    tacu_cus_id = document.getElementById('tacu_cus_id' + id).value;

    var http = new XMLHttpRequest();
    var url = "../gethint/gethint.php";
    var params = 'xml=<request><tipo>getMailFromUser</tipo><tacu_cus_id>' + tacu_cus_id  + '</tacu_cus_id></request>';
    http.open("POST", url, true);

    //Send the proper header information along with the request
    http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            
    http.onreadystatechange = function() {//Call a function when the state changes.
        if(http.readyState == 4 && http.status == 200) { 
            retorno = http.responseText;
            document.getElementById('tacu_email' + id).value = retorno.trim();
        }
    }
    http.send(params);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var tacu_idAUX = 0;

function addConvidado(){

    tacu_idAUX = tacu_idAUX + 1;

    el = '  <tr id="tacu_id' + tacu_idAUX + '">' +
                '<td style=" text-align: center; vertical-align: middle !important;">' +
                '<img    src="../_img/1810747.png"' +
                        'title="Excluir este recurso ou evento desta lista!"' +
                        'width="22"' +
                        'height="22" ' +
                        'onclick="deletaConvidado(' + tacu_idAUX + ')">' +
                '</td>' +
                '<input  type="hidden"' +
                        'class="tacu_volatil"' +
                        'value="N">' +
                '<td>' +
                    '<input  type="text"' +
                            'class="fullInputEmbalagem cursorPointer tacu_convidado"' +
                            'readonly ' +
                            'column="tacu_convidado"' +
                            'id="tacu_convidado' + tacu_idAUX + '"' +
                            'onclick="abreTelaConvidado(' + tacu_idAUX + ')"' +
                            'placeholder="Selecione um Convidado...">' +
                    '<input  type="hidden"' +
                            'id="tacu_cus_id' + tacu_idAUX + '"' +
                            'class="tacu_cus_id"' +
                            'column="tacu_cus_id"' +
                            'value="0">' +
                '</td>' +
                '<td>' +
                    '<input  type="text"' +
                            'class="fullInputEmbalagem tacu_email"' +
                            'readonly ' +
                            'column="tacu_email" ' +
                            'id="tacu_email' + tacu_idAUX + '">' +
                '</td>' +
            '</tr>';
    
    $('#convidadoContainer').append(el);
}

function addConvidadoVolatil(){

    tacu_idAUX = tacu_idAUX + 1;

    el = '  <tr id="tacu_id' + tacu_idAUX + '">' +
                '<td style=" text-align: center; vertical-align: middle !important;">' +
                '<img    src="../_img/1810747.png"' +
                        'title="Excluir este recurso ou evento desta lista!"' +
                        'width="22"' +
                        'height="22" ' +
                        'onclick="deletaConvidado(' + tacu_idAUX + ')">' +
                '</td>' +
                '<input  type="hidden"' +
                        'class="tacu_volatil"' +
                        'value="S">' +
                '<td>' +
                    '<input  type="text"' +
                            'class="fullInputEmbalagem cursorPointer tacu_convidado"' +
                            'column="tacu_convidado"' +
                            'id="tacu_convidado' + tacu_idAUX + '"' +
                            'placeholder="Insira um Convidado Volátil...">' +
                    '<input  type="hidden"' +
                            'id="tacu_cus_id' + tacu_idAUX + '"' +
                            'class="tacu_cus_id"' +
                            'column="tacu_cus_id"' +
                            'value="0">' +
                '</td>' +
                '<td>' +
                    '<input  type="text"' +
                            'class="fullInputEmbalagem tacu_email"' +
                            'column="tacu_email"' +
                            'id="tacu_email' + tacu_idAUX + '"' +
                            'placeholder="Insira o e-mail do Convidado Volátil...">' +
                '</td>' +
            '</tr>';
    $('#convidadoContainer').append(el);
}



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function deletaRota(id){
    confirma = confirm('Confirma a exclusão deste ponto da rota?');
    if(confirma){$('#tab_agenda_rota' + id).remove();}
}

var tar_idAUX = 0;

function addRota(){

    tar_idAUX = tar_idAUX + 1;

    el = '  <tr id="tab_agenda_rota' + tar_idAUX + '" tar_idAUX="' + tar_idAUX + '">' +
                '<td style=" text-align: center; vertical-align: middle !important;">' +
                    '<img   src="../_img/1810747.png"' +
                            'title="Excluir este ponto da rota!"' +
                            'width="22"' +
                            'height="22"' +
                            'onclick="deletaRota(' + tar_idAUX + ')"> ' +
                    '<img   src="../_img/down.png"' +
                            'title="Excluir este ponto da rota!"' +
                            'width="22"' +
                            'height="22"' +
                            'onclick="moveDownRota(' + tar_idAUX + ')"> ' +
                    '<img   src="../_img/up.png"' +
                            'title="Excluir este ponto da rota!"' +
                            'width="22"' +
                            'height="22"' +
                            'onclick="moveUpRota(' + tar_idAUX + ')">' +
                '</td>' +
                '<td>' +
                    '<select     class="fullInputEmbalagem ' +
                                'tar_ctp_id" ' +
                                'column="tar_ctp_id">' +
                                    '<option value="1">Parada Intermediária</option>' +
                                    '<option value="2">Destino</option>' +
                                    '<option value="3">Ponto de Referência</option>' +
                                    '<option value="4">Posto de Gasolina</option>' +
                                    '<option value="5">Restaurante</option>' +
                                    '<option value="6">Hotel ou Hospedagem</option>' +
                                    '<option value="7">Área de Descanso</option>' +
                                    '<option value="8">Cidade ou Município</option>' +
                                    '<option value="9">Pedágio</option>' +
                    '</select>' +
                '</td>' +
                '<td>' +
                    '<input  type="text" ' +
                            'class="fullInputEmbalagem tar_ponto" ' +
                            'column="tar_ponto" ' +
                            'placeholder="Insira uma descrição do local...">' +
                '</td>' +
            '</tr>';
    $('#rotaContainer').append(el);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function moveDownRota(id) {
    var row = document.getElementById('tab_agenda_rota' + id);
    console.log(row);

    var nextRow = row.nextElementSibling; // Correção: nextElementSibling
        
    if (nextRow) {
        // Se há uma próxima linha, mova a linha atual para baixo
        row.parentElement.insertBefore(row, nextRow.nextElementSibling);
    }
}

function moveUpRota(id) {
    var row = document.getElementById('tab_agenda_rota' + id);
    console.log(row);

    var previousRow = row.previousElementSibling; // Encontre a linha anterior

    if (previousRow) {
        // Se houver uma linha anterior, mova a linha atual para cima
        row.parentElement.insertBefore(row, previousRow);
    }
}




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function verificao_tab_agenda_periodo_agendamento(){
    var tbodyElement = document.getElementById('periodoAgendamentoContainer');
    var rows = tbodyElement.getElementsByTagName('tr');
    var jsonArray = [];
    var tudoCerto = true;

    for (var i = 0; i < rows.length; i++) {
        var row = rows[i];
        var columns = row.getElementsByTagName('input');
        var rowData = {};

        for (var j = 0; j < columns.length; j++) {
            var column = columns[j].getAttribute('column');
            var value = columns[j].value;
            rowData[column] = value;
        }

        jsonArray.push(rowData);
    }

    var jsonResult = JSON.stringify(jsonArray, null, 2);
    if(jsonResult == '[]'){
        tudoCerto = false;
        alert('Violação! A tabela de Períodos de Agendamentos está vazia!');
    }
    console.log(jsonResult);

    $('#tab_agenda_periodo_agendamento').val(jsonResult);

    var allFieldsComplete = true;

    for (var i = 0; i < rows.length; i++) {
        var row = rows[i];
        var inputs = row.getElementsByTagName('input');
        
        for (var j = 0; j < inputs.length; j++) {
            if (inputs[j].value.trim() === '') {
                allFieldsComplete = false;
                // Se um campo estiver vazio, você pode adicionar uma borda vermelha ao campo.
                inputs[j].style.border = '1px solid red';
            }
        }
    }

    if (!allFieldsComplete) {
        alert('Preencha todos os campos obrigatórios.');
        tudoCerto = false;
    }

    return tudoCerto;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    function verificao_tab_agenda_rota(){
        var tbodyElement = document.getElementById('recursoContainer');
        var selectElements = tbodyElement.querySelectorAll('.tacre_cta_id');

        var tudoCerto = true;

        count2 = 0;

        selectElements.forEach((select) => {
            if (select.value == '2') { count2++; }
        });

        if(count2 > 0){
            var tbodyElement = document.getElementById('rotaContainer');
            var rows = tbodyElement.getElementsByTagName('tr');
            var hasAtLeastOneRow = rows.length > 0;
            var allTarPontoFieldsComplete = true;

            if (hasAtLeastOneRow) {
                for (var i = 0; i < rows.length; i++) {
                    var row = rows[i];
                    var tarPontoInputs = row.querySelectorAll('.tar_ponto');
                    
                    for (var j = 0; j < tarPontoInputs.length; j++) {
                        tarPontoInputs[j].style.border = '0px solid red';
                        if (tarPontoInputs[j].value.trim() === '') {
                            allTarPontoFieldsComplete = false;
                            // Adicione uma borda vermelha ao campo ou outra ação necessária.
                            tarPontoInputs[j].style.border = '1px solid red';
                        }
                    }
                }
            }

            if(!hasAtLeastOneRow){
                alert('Violação! A tabela de Rota está vazia!');
                var tudoCerto = false;
            }
            if(!allTarPontoFieldsComplete){
                alert('Violação! Existe um campo incompletro na tabela de Rota!');
                var tudoCerto = false;
            }

        }

        var tbodyElement = document.getElementById('rotaContainer');
        var rows = tbodyElement.getElementsByTagName('tr');
        var jsonRows = [];

        for (var i = 0; i < rows.length; i++) {
            var row = rows[i];
            var selectElement = row.querySelector('.tar_ctp_id');
            var inputElement = row.querySelector('.tar_ponto');
            
            if (selectElement && inputElement) {
                var rowData = {
                    tar_ctp_id: selectElement.value,
                    tar_ponto: inputElement.value
                };
                jsonRows.push(rowData);
            }
        }

        // Converter o array de objetos em uma string JSON
        var jsonString = JSON.stringify(jsonRows);

        console.log(jsonString);

        $('#tab_agenda_rota').val(jsonString);


        return tudoCerto;

        
    }

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function tab_agenda_x_cad_usuario(){
    var tbodyElement = document.getElementById('convidadoContainer');
    var rows = tbodyElement.getElementsByTagName('tr');
    var jsonRows = [];
    var saida = true;

    for (var i = 0; i < rows.length; i++) {
        var row = rows[i];
        var convidadoElement = row.querySelector('.tacu_convidado');
        var cusIdElement = row.querySelector('.tacu_cus_id');
        var emailElement = row.querySelector('.tacu_email');
        var volatElement = row.querySelector('.tacu_volatil');
        
        if (convidadoElement && cusIdElement && emailElement) {
            var rowData = {
                tacu_convidado: convidadoElement.value,
                tacu_cus_id: cusIdElement.value,
                tacu_email: emailElement.value,
                tacu_volatil: volatElement.value
            };
            jsonRows.push(rowData);
        }
    }

    // Converter o array de objetos em uma string JSON
    var jsonString = JSON.stringify(jsonRows); 

    console.log(jsonString);

    if(document.getElementById('tag_vou_participar').value == 'N' && jsonString == '[]'){
        alert('Violação! Se o anfitrião não participar do agendamento é necessário incluír um convidado!');
        saida = false;
    }

    $('#tab_agenda_x_cad_usuario').val(jsonString);
    return saida;

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function verificacaAnfitriao(id) {
    var tag_vou_participar = $('#tag_vou_participar').val();

    if(id == 0){
        tvp              = document.querySelector('.tag_vou_participar ');
        tvp.style.border = '0px solid red';
    }

    if (tag_vou_participar === 'S') {
        var tbodyElement = document.getElementById('periodoAgendamentoContainer');
        var rows = tbodyElement.getElementsByTagName('tr');

        if(id < rows.length){
            var row = rows[id];

            var capa_data_inicio = row.querySelector('.capa_data_inicio');
            var capa_data_fim = row.querySelector('.capa_data_fim');

            capa_data_inicio.style.border   = '0px solid red';
            capa_data_fim.style.border      = '0px solid red';

            if(capa_data_inicio.value && capa_data_fim.value){
                var http = new XMLHttpRequest();
                var url = "../gethint/gethint.php";
                var params = 'xml=<request><tipo>verificacaAnfitriao</tipo><cus_id>' + cus_id  + '</cus_id><capa_data_inicio>' + capa_data_inicio.value  + '</capa_data_inicio><capa_data_fim>' + capa_data_fim.value  + '</capa_data_fim></request>';
                http.open("POST", url, true);
            
                //Send the proper header information along with the request
                http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                        
                http.onreadystatechange = function() {//Call a function when the state changes.
                    if(http.readyState == 4 && http.status == 200) { 
                        retorno = http.responseText;
                        console.log(retorno);
                        //alert(retorno);
                        var jsonObject = JSON.parse(retorno);
                        if(jsonObject.erro == 'true'){
                            /// mudar a cor dos campos incorretos
                            capa_data_inicio.style.border   = '1px solid red';
                            capa_data_fim.style.border      = '1px solid red';
                            tvp              = document.querySelector('.tag_vou_participar ');
                            tvp.style.border = '2px solid red';
                            alert('Verifique sua agenda! Você tem conflito com outros agendamentos!');
                            xTudoCerto = false;
                        }
                        verificacaAnfitriao(id + 1);
                    }
                }
                http.send(params);
            }else{
                xTudoCerto = false;
                verificacaAnfitriao(id + 1);
            }

        }else{
            //proxima rotina
            verificaRecursoAgendamento(0,0);
        }
    }else{
        //proxima rotina
        verificaRecursoAgendamento(0,0);
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function verificaRecursoAgendamento(idRA, idPA){

    if(idRA == 0 && idPA == 0){
        tcd = document.querySelector('.tacre_cre_descricao');
        cdi = document.querySelector('.capa_data_inicio');
        cdf = document.querySelector('.capa_data_fim');

        tcd.style.border    = '0px solid red';
        cdi.style.border    = '0px solid red';
        cdf.style.border    = '0px solid red';
    }

    var recursoContainer    = document.getElementById('recursoContainer');
    var rowsRA              = recursoContainer.getElementsByTagName('tr');

    var periodoAgendamentoContainer     = document.getElementById('periodoAgendamentoContainer');
    var rowsPA                          = periodoAgendamentoContainer.getElementsByTagName('tr');


    //verificar lista de eventos e recursos
    if(idRA < rowsRA.length){
        var rowRA = rowsRA[idRA];

        var tacre_cre_id        = rowRA.querySelector('.tacre_cre_id');
        var tacre_cre_descricao = rowRA.querySelector('.tacre_cre_descricao');

        if(idPA < rowsPA.length){
            var rowPA = rowsPA[idPA];

            var capa_data_inicio    = rowPA.querySelector('.capa_data_inicio');
            var capa_data_fim       = rowPA.querySelector('.capa_data_fim');

            if(capa_data_inicio.value && capa_data_fim.value){
                var http = new XMLHttpRequest();
                var url = "../gethint/gethint.php";
                var params = 'xml=<request><tipo>verificaRecursoAgendamento</tipo><tacre_cre_id>' + tacre_cre_id.value  + '</tacre_cre_id><capa_data_inicio>' + capa_data_inicio.value  + '</capa_data_inicio><capa_data_fim>' + capa_data_fim.value  + '</capa_data_fim></request>';
                http.open("POST", url, true);
            
                //Send the proper header information along with the request
                http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                        
                http.onreadystatechange = function() {//Call a function when the state changes.
                    if(http.readyState == 4 && http.status == 200) { 
                        retorno = http.responseText;
                        console.log(retorno);
                        var jsonObject = JSON.parse(retorno);
                        if(jsonObject.erro == 'true'){
                            /// mudar a cor dos campos incorretos
                            capa_data_inicio.style.border       = '1px solid red';
                            capa_data_fim.style.border          = '1px solid red';
                            tacre_cre_descricao.style.border    = '1px solid red';
                            alert('Verifique sua agenda! Um ou mais itens possuem conflitos de agenda!');
                            xTudoCerto = false;
                        }
                        verificaRecursoAgendamento(idRA, idPA + 1);
                    }
                }
                http.send(params);
            }else{
                xTudoCerto = false;
                verificaRecursoAgendamento(idRA, idPA + 1);
            }


            //verificaRecursoAgendamento(idRA, idPA + 1);
        }else{
            verificaRecursoAgendamento(idRA + 1, 0);
        }
    }else{
        //proxima rotina
        verificaConvidados(0,0);
    }


}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function verificaConvidados(idCO, idPA){

    if(idCO == 0 && idPA == 0){
        tco = document.querySelector('.tacu_convidado');
        tem = document.querySelector('.tacu_email');
        cdi = document.querySelector('.capa_data_inicio');
        cdf = document.querySelector('.capa_data_fim');

        if(tco){
            tco.style.border    = '0px solid red';
            tem.style.border    = '0px solid red';
            cdi.style.border    = '0px solid red';
            cdf.style.border    = '0px solid red';
        }
    }

    var convidadoContainer              = document.getElementById('convidadoContainer');
    var rowsCO                          = convidadoContainer.getElementsByTagName('tr');

    var periodoAgendamentoContainer     = document.getElementById('periodoAgendamentoContainer');
    var rowsPA                          = periodoAgendamentoContainer.getElementsByTagName('tr');

    if(idCO < rowsCO.length){
        var rowCO = rowsCO[idCO];

        var tacu_cus_id         = rowCO.querySelector('.tacu_cus_id');
        var tacu_convidado      = rowCO.querySelector('.tacu_convidado');
        var tacu_email          = rowCO.querySelector('.tacu_email');

        if(idPA < rowsPA.length){
            var rowPA = rowsPA[idPA];

            var capa_data_inicio    = rowPA.querySelector('.capa_data_inicio');
            var capa_data_fim       = rowPA.querySelector('.capa_data_fim');

            if(tacu_cus_id != '0' && capa_data_inicio.value && capa_data_fim.value){
                
                var http = new XMLHttpRequest();
                var url = "../gethint/gethint.php";
                var params = 'xml=  <request>' +
                                        '<tipo>verificaConvidado</tipo>' +
                                        '<tacu_cus_id>' + tacu_cus_id.value  + '</tacu_cus_id>' +
                                        '<capa_data_inicio>' + capa_data_inicio.value  + '</capa_data_inicio>' +
                                        '<capa_data_fim>' + capa_data_fim.value  + '</capa_data_fim>' +
                                    '</request>';
                console.log(params);
                http.open("POST", url, true);
            
                //Send the proper header information along with the request
                http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                        
                http.onreadystatechange = function() {//Call a function when the state changes.
                    if(http.readyState == 4 && http.status == 200) { 
                        retorno = http.responseText;
                        console.log(retorno);
                        var jsonObject = JSON.parse(retorno);
                        if(jsonObject.erro == 'true'){
                            /// mudar a cor dos campos incorretos
                            tacu_convidado.style.border     = '1px solid red';
                            tacu_email.style.border         = '1px solid red';
                            capa_data_inicio.style.border   = '1px solid red';
                            capa_data_fim.style.border      = '1px solid red';
                            alert('Verifique sua agenda! Um ou mais convidados possuem conflitos de agenda!');
                            xTudoCerto = false;
                        }
                        verificaConvidados(idCO, idPA + 1);
                    }
                }
                http.send(params);
            }else{
                xTudoCerto = false;
                verificaConvidados(idCO, idPA + 1);
            }
            //verificaConvidados(idCO, idPA + 1);
        }else{
            verificaConvidados(idCO + 1, 0);
        }
    }else{
        verificaPA();
    }

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function verificaPA(){
    var periodoAgendamentoContainer     = document.getElementById('periodoAgendamentoContainer');
    var rowsPA                          = periodoAgendamentoContainer.getElementsByTagName('tr');

    for (var j = 0; j < rowsPA.length; j++) {
        var rowPA = rowsPA[j];

        var capa_data_inicio    = rowPA.querySelector('.capa_data_inicio');
        var capa_data_fim       = rowPA.querySelector('.capa_data_fim');

        if(capa_data_inicio.value && capa_data_fim.value){
            if(capa_data_inicio.value > capa_data_fim.value){
                alert('Verifique sua agenda! A data de início não pode ser maior que a data de fim nos Períodos de Agendamentos!');
                xTudoCerto = false;
            }
        }else{
            alert('Verifique sua agenda! Um ou mais campos de Períodos de Agendamentos estão vazio/s!');
            xTudoCerto = false;
        }
    }

    enviaFormulario();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

$('.ClickMandaForm').click(function(){
    
    xTudoCerto = true;

    var verifica_validacaorecursoEventoOnBackEnd = false;

    var verifica_tab_agenda_periodo_agendamento = false;

    var verifica_tab_agenda_rota = false;

    var verifica_tab_agenda_x_cad_usuario = false;

    validacaorecursoEventoOnBackEnd(function(erro) { verifica_validacaorecursoEventoOnBackEnd = true; });

    verifica_tab_agenda_periodo_agendamento = verificao_tab_agenda_periodo_agendamento();

    verifica_tab_agenda_rota = verificao_tab_agenda_rota();

    verifica_tab_agenda_x_cad_usuario = tab_agenda_x_cad_usuario();

    verificacaAnfitriao(0);

    //validar lista de recursos e eventos
    if(
        validaRecursoEvento() && 
        verifica_validacaorecursoEventoOnBackEnd && 
        verifica_tab_agenda_periodo_agendamento &&
        verifica_tab_agenda_rota &&
        verifica_tab_agenda_x_cad_usuario){

            verificacaAnfitriao(0);
        }
});


function enviaFormulario(){
    
    if(xTudoCerto && document.getElementById('tag_descricao').value != ''){
        $('.glassLoad').show();
        $('.gifLoad').show();
        $('.ClickMandaForm').hide();
        $('#mandaForm').click();
    }
}
