// Função para definir um cookie 
function setCookie(name, value, days) {
    const date = new Date();
    date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
    const expires = "expires=" + date.toUTCString();
    document.cookie = name + "=" + value + ";" + expires + ";path=/";
  }
  
  // Função para obter a string JSON e definir o cookie
  function createAndSetCookie() {
    const inputElements = document.querySelectorAll('.inputFilter');
    const jsonData = {};
  
    inputElements.forEach(function(inputElement) {
      const id = inputElement.id;
      const value = inputElement.value;
      jsonData[id] = value;
    });
  
    const jsonString = JSON.stringify(jsonData);
    setCookie('itemFiltro', jsonString, 30); // Define o cookie 'itemFiltro' com a string JSON por 30 dias
  }
  
  // Adicione o evento onkeyup a todos os elementos com a classe inputFilter
  const inputElements = document.querySelectorAll('.inputFilter');
  inputElements.forEach(function(inputElement) {
    inputElement.addEventListener('keyup', createAndSetCookie);
  });
  
  // Função para ler um cookie pelo nome
  function getCookie(name) {
    const cookies = document.cookie.split(';');
    for (let i = 0; i < cookies.length; i++) {
      const cookie = cookies[i].trim();
      if (cookie.startsWith(name + '=')) {
        return cookie.substring(name.length + 1);
      }
    }
    return null;
  }
  
  // Função para preencher os inputs com base nos valores do JSON
  function fillInputsFromCookie() {
    const jsonString = getCookie('itemFiltro');
    
    if (jsonString) {
      const jsonData = JSON.parse(jsonString);
  
      for (const id in jsonData) {
        const value = jsonData[id];
        const inputElement = document.getElementById(id);
  
        if (inputElement) {
          inputElement.value = value;
        }
      }
      reloadTab(jsonData[0]);
    }
    
  }
  
  // Chame a função para preencher os inputs quando a página for carregada
  document.addEventListener('DOMContentLoaded', fillInputsFromCookie);