import requests
import json
import psycopg2
from google.auth.transport.requests import Request
from google.oauth2.service_account import Credentials

# Conexão com o banco de dados
conn = psycopg2.connect(
    dbname="nev_agenda",    # Substitua pelo nome do seu banco de dados
    user="dev_nevoeiro",            # Substitua pelo seu usuário
    password="S98!@35x",          # Substitua pela sua senha
    host="192.168.253.245",              # Ou o endereço do servidor
    port="5432"                    # Substitua se estiver usando uma porta diferente
)

cur = conn.cursor()

# Define a consulta SQL
sql_query = """
    SELECT tn.tno_id, tn.tno_titulo, tn.tno_mensagem, cu.cus_fcm_token, tn.tno_ctn_id, tn.tno_tab_id
    FROM tab_notificacao as tn
    INNER JOIN cad_usuario as cu ON cu.cus_id = tn.tno_cus_id
    WHERE tn.tno_status_app = 'N'
    AND tn.tno_status = 'S'
    AND (cu.cus_fcm_token IS NOT NULL OR cu.cus_fcm_token != '')
"""

cur.execute(sql_query)

# Recupera os resultados
results = cur.fetchall()

# Credenciais de serviço do Firebase
SCOPES = ["https://www.googleapis.com/auth/firebase.messaging"]
SERVICE_ACCOUNT_FILE = "agenda-feeae-4ba6307f80b4.json"  # Substitua pelo caminho da sua chave JSON

# Autenticando com credenciais de serviço
credentials = Credentials.from_service_account_file(SERVICE_ACCOUNT_FILE, scopes=SCOPES)
credentials.refresh(Request())
access_token = credentials.token

# URL da API FCM
fcm_url = "https://fcm.googleapis.com/v1/projects/agenda-feeae/messages:send"

# Cabeçalhos HTTP
headers = {
    'Authorization': f'Bearer {access_token}',
    'Content-Type': 'application/json; UTF-8',
}

# Envio da notificação para cada resultado
for row in results:
    tno_id, tno_titulo, tno_mensagem, cus_fcm_token, tno_ctn_id, tno_tab_id = row

    # Substitui <br> por nada na mensagem
    tno_mensagem = tno_mensagem.replace('<br>', '')

    # Payload da mensagem
    message = {
        "message": {
            "token": cus_fcm_token,
            "notification": {
                "title": tno_titulo,
                "body": tno_mensagem
            },
            "data": {
                "parametro": json.dumps([
                    {"tno_ctn_id": tno_ctn_id, "tno_tab_id": tno_tab_id}
                ])
            }
        }
    }

    # Envio da mensagem
    response = requests.post(fcm_url, headers=headers, data=json.dumps(message))

    # Atualiza o status no banco de dados após o envio
    if response.status_code == 200:
        cur.execute("UPDATE tab_notificacao SET tno_status_app = 'S' WHERE tno_id = %s", (tno_id,))
        conn.commit()
        print(f"Mensagem enviada com sucesso para o token: {cus_fcm_token}")
    else:
        print(f"Falha no envio: {response.status_code} - {response.text}")

# Fecha o cursor e a conexão
cur.close()
conn.close()

#input("Pressione Enter para continuar...") teste
