<?php
    include('../connection_pgsql/connection_pg.php');
	include('../functions/pg_functions.php');
	//include('../gethint/protocolo.php');
	include('../gethint/functions_old.php');


	$query = "	WITH lista_lp AS(
					SELECT 
						cre.cre_id,
						cre.cre_device_id,
						MAX(tvl.tvl_updated_at) AS tvl_updated_at
					FROM cad_recurso_evento AS cre
						LEFT JOIN tab_veiculo_localizacao AS tvl ON tvl.tvl_cre_id = cre.cre_id
					WHERE cre.cre_cta_id = 2 AND cre.cre_status = 'S' AND cre.cre_device_id != ''
					GROUP BY 1,2)
					SELECT
						cre_id,
						cre_device_id,
						CASE WHEN tvl_updated_at IS NOT NULL THEN tvl_updated_at ELSE '2000-01-01 00:00:00'::TIMESTAMP END AS tvl_updated_at
					FROM lista_lp";

    $saida = DBdirectQuery($connection_data,$query);

    foreach ($saida as $saidaX) {

    	$url = "https://api.cobli.co/public/v1/devices/{$saidaX['cre_device_id']}/telemetry";
		$apiKey = "wLnr6Xt.0064abbc-de35-4289-a604-adc721298fec";

		// Inicializa a sessão cURL
		$ch = curl_init($url);

		// Configura as opções da solicitação cURL
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array(
			"accept: application/json",
			"cobli-api-key: " . $apiKey
		));

		// Executa a solicitação e armazena a resposta
		$response = curl_exec($ch);


		$data = json_decode($response, true);

		// Acessar os valores
		$latitude = $data['data']['latitude'];
		$longitude = $data['data']['longitude'];

		$updated_at = new DateTime($data['data']['updated_at']);
		$updated_at->modify('-3 hours');
		$updated_atx = $updated_at;
		$updated_at = $updated_at->getTimestamp();

		$speed = $data['data']['speed'];
		$ignition_on = $data['data']['ignition_on'];


		$tvl_updated_at = new DateTime($saidaX['tvl_updated_at']);
		$tvl_updated_at->modify('-3 hours');
		$tvl_updated_at = $tvl_updated_at->getTimestamp();

		//echo tvl_updated_at.'<br>';
		//echo updated_at.'<br>';

		if($tvl_updated_at != $updated_at){
			$json_data = get_address($latitude,$longitude);
			$datax = json_decode($json_data, true);
			$place_id = $datax['place_id'];
			$address = $datax['address'];
			if(isset($address['amenity'])){	$amenity = $address['amenity']; } else {$amenity = '';}
			if(isset($address['suburb'])){	$suburb = $address['suburb']; } else {$suburb = '';}
			if(isset($address['road'])){	$road = $address['road']; } else {$road = '';}
			if(isset($address['city'])){
				$city = $address['city'];
			}elseif(isset($address['village'])){
				$city = $address['village'];
			}elseif(isset($address['town'])){
				$city = $address['town'];
			}else{
				$city = '';
			}

			if ($ignition_on) {
			    $ignition_on = 'S';
			} else {
			    $ignition_on = 'N';
			}

			$updated_atx = $updated_atx->format('Y-m-d H:i:s');

			$tab_veiculo_localizacao = array(
				"tvl_cre_id" 		=> $saidaX['cre_id'],
				"tvl_latitude" 		=> $latitude,
				"tvl_longitude" 	=> $longitude,
				"tvl_updated_at" 	=> $updated_atx,
				"tvl_speed" 		=> $speed,
				"tvl_ignition_on" 	=> $ignition_on,
				"tvl_amenity" 		=> $amenity,
				"tvl_road" 			=> $road,
				"tvl_suburb" 		=> $suburb,
				"tvl_city" 			=> $city,
			);
			DBcreate($connection_data, 'tab_veiculo_localizacao', $tab_veiculo_localizacao);
		}
		// Fecha a sessão cURL
		curl_close($ch);
    }


    function get_address($latitude, $longitude) {
	    // Formatar a URL da API
	    $api_url = "https://nominatim.openstreetmap.org/reverse?format=json&lat={$latitude}&lon={$longitude}";

	    // Inicializar cURL
	    $curl = curl_init();

	    // Definir as opções cURL
	    curl_setopt($curl, CURLOPT_URL, $api_url);
	    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	     curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36');


	    // Executar a requisição
	    $response = curl_exec($curl);

	    curl_close($curl);

	    return $response;
	}