<?php
    include('../connection_pgsql/connection_pg.php');
	include('../functions/pg_functions.php');
	//include('../gethint/protocolo.php');
	include('../gethint/functions_old.php');

    $query = "WITH data_movimentacao AS (
			    SELECT
			        tvl_cre_id,
			        MIN(tvl_id) AS tvl_id_min,
			        MAX(tvl_id) AS tvl_id_max,
			        MIN(tvl.tvl_updated_at) AS tvl_updated_at_min,
			        MAX(tvl.tvl_updated_at) AS tvl_updated_at_max
			    FROM
			        tab_veiculo_localizacao AS tvl
			    WHERE
			        tvl_updated_at >= NOW() - INTERVAL '210 minutes'
			    GROUP BY tvl_cre_id
			)

				
			SELECT
			    dt.*,
			    (6371 * acos(
			        cos(radians(tvl_min.tvl_latitude)) * cos(radians(tvl_max.tvl_latitude)) *
			        cos(radians(tvl_max.tvl_longitude) - radians(tvl_min.tvl_longitude)) +
			        sin(radians(tvl_min.tvl_latitude)) * sin(radians(tvl_max.tvl_latitude))
			    ))::integer AS distancia_em_km,
			    'AMSA_' || dt.tvl_cre_id || '_' || to_char(dt.tvl_updated_at_max, 'DDMMYYYY_HH24') AS controle,
			    cre.cre_descricao,
			    cre.cre_cus_id_resposavel
			FROM
			    data_movimentacao AS dt
			LEFT JOIN tab_veiculo_localizacao AS tvl_min ON tvl_min.tvl_id = dt.tvl_id_min
			LEFT JOIN tab_veiculo_localizacao AS tvl_max ON tvl_max.tvl_id = dt.tvl_id_max

			INNER JOIN cad_recurso_evento AS cre ON cre.cre_id = dt.tvl_cre_id

			WHERE
				NOT EXISTS(SELECT tn.tno_controle FROM tab_notificacao AS tn WHERE tn.tno_controle = 'AMSA_' || dt.tvl_cre_id || '_' || to_char(dt.tvl_updated_at_max, 'DDMMYYYY_HH24'))
				and
				dt.tvl_id_min != dt.tvl_id_max AND NOT EXISTS (
																			SELECT
																				*
																			FROM tab_agenda_periodo_agendamento AS tapa
																				INNER JOIN tab_agenda_x_cad_recurso_evento AS tacre ON tacre.tacre_tag_id = tapa.capa_tag_id
																				INNER JOIN cad_recurso_evento AS cre2 ON cre.cre_id = tacre.tacre_cre_id
																				INNER JOIN tab_agenda AS ta ON ta.tag_id = tapa.capa_tag_id
																			
																			WHERE
																				cre2.cre_id = cre.cre_id and
																				(
																				(ta.tag_status = 'S' AND tapa.capa_data_inicio <= tvl_updated_at_min /*Data Inicial*/ AND tapa.capa_data_inicio >= tvl_updated_at_max /*Data Final*/ AND tapa.capa_data_fim <= tvl_updated_at_max /*Data Final*/)
																				or
																				(ta.tag_status = 'S' AND tapa.capa_data_inicio >= tvl_updated_at_min /*Data Inicial*/ AND tapa.capa_data_fim <= tvl_updated_at_min /*Data Inicial*/ AND tapa.capa_data_fim >= tvl_updated_at_max /*Data Final*/)
																				or
																				(ta.tag_status = 'S' AND tapa.capa_data_inicio >= tvl_updated_at_min /*Data Inicial*/ AND tapa.capa_data_fim <= tvl_updated_at_max AND tapa.capa_data_fim >= tvl_updated_at_min /*Data Inicial*/ AND tapa.capa_data_fim <= tvl_updated_at_max)
																				or
																				(ta.tag_status = 'S' AND tapa.capa_data_inicio <= tvl_updated_at_min /*Data Inicial*/ AND tapa.capa_data_fim <= tvl_updated_at_max /*Data Final*/))
																			
																			)";

		$alertas = DBdirectQuery($connection_data,$query);


	if(is_array($alertas)){
        foreach($alertas as $X){
            $tab_notificacao = array(
                    "tno_ctn_id"    => 4,
                    "tno_tab_id"    => 6,
                    "tno_titulo"    => 'Movimentação de veículo sem agendamento',
                    "tno_mensagem"  => 'O veículo '.$X['cre_descricao'].' se movimentou cerca de '.$X['distancia_em_km'].' km nos últimos 30 minutos sem agendamento!',
                    "tno_cus_id"    => $X['cre_cus_id_resposavel'],
                    "tno_data_ins"  => date('Y-m-d H:i:s'),
                    "tno_controle"  => $X['controle']
            );
            DBcreate($connection_data, 'tab_notificacao', $tab_notificacao);
        } 
    }
