<?php
	include('../connection_pgsql/connection_pg.php');
	include('../functions/pg_functions.php');
	include('mail_recuperacao_senha.php');
	include('../gethint/functions_old.php');

	set_time_limit(0);

// Lista de scripts a serem executados
$json_scripts = '[
    {"script": "insert_petros_item.php"},
    {"script": "insert_petros_item_empresa.php"},
    {"script": "insert_petros_embalagem_item.php"},
    {"script": "update_petros_item.php"},
    {"script": "update_petros_embalagem_item.php"},
    {"script": "update_petros_item_empresa.php"}
]';


$scripts = json_decode($json_scripts, true);

foreach($scripts as $script){
    echo $script['script'];
    echo '<br>';

    ob_start(); // Inicia o buffer de saída
    require_once $script['script'];
    $output = ob_get_clean();
    echo $output;
    echo '<br>';
    echo '<br>';
}
DBdirectQuery($connection_data_petros, f_sis_auditoria_tabela_petros());

function debug($connection_data, $table, $debug_msg, $where, $others = null){
    if($others == null){
        $UpQ = "UPDATE
                    {$table} 
                SET
                debug = case
                        WHEN debug IS NULL OR debug = '' THEN 
                        to_char(NOW(), 'YYYY-MM-DD HH24:MI:SS') || ' - {$debug_msg}'
                        ELSE debug || '
' || to_char(NOW(), 'YYYY-MM-DD HH24:MI:SS') || ' - {$debug_msg}'
                        END
                 where {$where}";
    }else{
        $UpQ = "UPDATE
                    {$table}  
                SET 
                {$others},
                debug = case
                        WHEN debug IS NULL OR debug = '' THEN 
                        to_char(NOW(), 'YYYY-MM-DD HH24:MI:SS') || ' - {$debug_msg}'
                        ELSE debug || '
' || to_char(NOW(), 'YYYY-MM-DD HH24:MI:SS') || ' - {$debug_msg}'
                        END
                        where {$where}";
    }
    $Qr = DBdirectQuery($connection_data, $UpQ);
}


function f_sis_auditoria_tabela_integra(){
    return "CREATE OR REPLACE FUNCTION public.f_sis_auditoria_tabela()
                RETURNS trigger
                LANGUAGE 'plpgsql'
                VOLATILE
                COST 100
            AS \$BODY\$
             DECLARE
                 linha_auditoria			public.sis_registro_alteracao;
                 colunas_excluidas		TEXT[] = ARRAY[]::TEXT[];
                 chave_primaria			TEXT[] = ARRAY[]::TEXT[];
                 alias_colunas			JSONB;
                 bypass_erro_limite_auditoria	BOOLEAN = FALSE;
             BEGIN
                  IF NOT EXISTS(SELECT	1
                      FROM	public.sis_tabela_auditoria AS sta
                      WHERE	sta.nome_tabela_auditoria = TG_TABLE_NAME::TEXT
                      AND	sta.auditoria_habilitada = 'S') THEN
                      RETURN NULL;
                  END IF;
                  
                 IF TG_WHEN <> 'AFTER' THEN
                     RAISE EXCEPTION 'f_sis_auditoria_tabela() só pode ser executado por um trigger do tipo AFTER';
                 END IF;
                 
                 EXECUTE 'SET search_path TO public';
                 
                 BEGIN
                     bypass_erro_limite_auditoria = CURRENT_SETTING('petros.bypass_erro_limite_auditoria') = 'S';
                 EXCEPTION
                     WHEN OTHERS THEN
                 END;
                 
                 IF (NOT(bypass_erro_limite_auditoria OR ((TG_OP = 'UPDATE' OR TG_OP = 'INSERT' OR TG_OP = 'DELETE') AND TG_TABLE_NAME::TEXT IN(SELECT sta.nome_tabela_auditoria FROM sis_tabela_auditoria sta WHERE sta.obrigatorio = 'S')))
                     AND EXISTS(SELECT 1
                         FROM	sis_parametro sp
                         WHERE	sp.id_parametro = 'interno.excedeu_limite_porcentagem_armazenamento_sis_registro_alteracao'
                         AND	sp.valor_alfanumerico = 'S')) THEN
                     RAISE EXCEPTION 'f_sis_auditoria_tabela() o processo de auditoria não pode ser realizado para a tabela [%] pois excedeu a capacidade de armazenamento permitida para a base. Desabilite a auditoria da tabela.', TG_TABLE_NAME::TEXT;
                 END IF;
                 linha_auditoria = ROW(
                     NEXTVAL('public.seq_registro_alteracao'),									/*id_registro_alteracao*/
                     (SELECT sta.id_tabela_auditoria FROM public.sis_tabela_auditoria AS sta WHERE TRIM(sta.nome_tabela_auditoria) = TRIM(TG_TABLE_NAME::TEXT)), /*nome_tabela*/
                     SESSION_USER::TEXT,															/*usuario_conexao*/
                     'EDUARDO',    																/*conta do usuário do PETROS*/
                    CLOCK_TIMESTAMP(),															/*data_registro_alteracao*/
                     SUBSTRING(TG_OP,1,1),														/*acao*/
                     NULL,																		/*registro_original*/
                     NULL,																		/*campos_alterados*/
                     FALSE,																		/*somente_comando*/
                     NULL																		/*chave_primaria*/
                     );
                 IF TG_ARGV[1] IS NOT NULL THEN
                     colunas_excluidas = TG_ARGV[1]::TEXT[];
                     IF (UPPER(TG_ARGV[1])::TEXT = '{NULL}') THEN
                         colunas_excluidas = ARRAY[]::TEXT[];
                     END IF;
                 END IF;
                 
                 IF TG_ARGV[2] IS NOT NULL THEN
                     chave_primaria = TG_ARGV[2]::TEXT[];
                 END IF;
                 
                 IF TG_ARGV[3] IS NOT NULL THEN
                     alias_colunas = TG_ARGV[3]::JSONB;
                 END IF;
                 IF (TG_OP = 'UPDATE' AND TG_LEVEL = 'ROW') THEN         
                     linha_auditoria.campos_alterados =  F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), TO_JSONB(OLD.*)) - colunas_excluidas - chave_primaria;
                     linha_auditoria.registro_original = F_SIS_SUBTRACAO_JSONB(TO_JSONB(OLD.*), F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), linha_auditoria.campos_alterados)) - colunas_excluidas - chave_primaria;
                     linha_auditoria.chave_primaria = F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), (TO_JSONB(NEW.*) - chave_primaria));
                     IF linha_auditoria.campos_alterados = CAST('{}' AS JSONB) THEN
                         RETURN NULL;
                     END IF;
                 ELSIF (TG_OP = 'DELETE' AND TG_LEVEL = 'ROW') THEN
                     linha_auditoria.registro_original = TO_JSONB(OLD.*) - colunas_excluidas - chave_primaria;
                     linha_auditoria.chave_primaria = F_SIS_SUBTRACAO_JSONB(TO_JSONB(OLD.*), (TO_JSONB(OLD.*) - chave_primaria));
                 ELSIF (TG_OP = 'INSERT' AND TG_LEVEL = 'ROW') THEN
                     linha_auditoria.registro_original = TO_JSONB(NEW.*) - colunas_excluidas - chave_primaria;
                     linha_auditoria.chave_primaria = F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), (TO_JSONB(NEW.*) - chave_primaria));
                 ELSIF (TG_LEVEL = 'STATEMENT' AND TG_OP IN ('INSERT','UPDATE','DELETE','TRUNCATE')) THEN
                     linha_auditoria.somente_comando = TRUE;
                 ELSE
                     RAISE EXCEPTION '[f_sis_auditoria_tabela] - Função adicionada como um trigger para um caso nao tratado: %, %',TG_OP, TG_LEVEL;
                 END IF;
                 
                 linha_auditoria.campos_alterados = (SELECT f_sis_substitui_alias_colunas_auditoria(TG_TABLE_NAME, linha_auditoria.campos_alterados, alias_colunas, 'G'));
                 linha_auditoria.registro_original = (SELECT f_sis_substitui_alias_colunas_auditoria(TG_TABLE_NAME, linha_auditoria.registro_original, alias_colunas, 'G'));
                 linha_auditoria.chave_primaria = (SELECT f_sis_substitui_alias_colunas_auditoria(TG_TABLE_NAME, linha_auditoria.chave_primaria, alias_colunas, 'G'));
                 INSERT INTO public.sis_registro_alteracao VALUES (linha_auditoria.*);
                 RETURN NULL;
             END;
             
            \$BODY\$;";
}

function f_sis_auditoria_tabela_petros(){
    return "CREATE OR REPLACE FUNCTION public.f_sis_auditoria_tabela()
                RETURNS trigger
                LANGUAGE 'plpgsql'
                VOLATILE
                COST 100
            AS \$BODY\$
             DECLARE
                 linha_auditoria			public.sis_registro_alteracao;
                 colunas_excluidas		TEXT[] = ARRAY[]::TEXT[];
                 chave_primaria			TEXT[] = ARRAY[]::TEXT[];
                 alias_colunas			JSONB;
                 bypass_erro_limite_auditoria	BOOLEAN = FALSE;
             BEGIN
                  IF NOT EXISTS(SELECT	1
                      FROM	public.sis_tabela_auditoria AS sta
                      WHERE	sta.nome_tabela_auditoria = TG_TABLE_NAME::TEXT
                      AND	sta.auditoria_habilitada = 'S') THEN
                      RETURN NULL;
                  END IF;
                  
                 IF TG_WHEN <> 'AFTER' THEN
                     RAISE EXCEPTION 'f_sis_auditoria_tabela() só pode ser executado por um trigger do tipo AFTER';
                 END IF;
                 
                 EXECUTE 'SET search_path TO public';
                 
                 BEGIN
                     bypass_erro_limite_auditoria = CURRENT_SETTING('petros.bypass_erro_limite_auditoria') = 'S';
                 EXCEPTION
                     WHEN OTHERS THEN
                 END;
                 
                 IF (NOT(bypass_erro_limite_auditoria OR ((TG_OP = 'UPDATE' OR TG_OP = 'INSERT' OR TG_OP = 'DELETE') AND TG_TABLE_NAME::TEXT IN(SELECT sta.nome_tabela_auditoria FROM sis_tabela_auditoria sta WHERE sta.obrigatorio = 'S')))
                     AND EXISTS(SELECT 1
                         FROM	sis_parametro sp
                         WHERE	sp.id_parametro = 'interno.excedeu_limite_porcentagem_armazenamento_sis_registro_alteracao'
                         AND	sp.valor_alfanumerico = 'S')) THEN
                     RAISE EXCEPTION 'f_sis_auditoria_tabela() o processo de auditoria não pode ser realizado para a tabela [%] pois excedeu a capacidade de armazenamento permitida para a base. Desabilite a auditoria da tabela.', TG_TABLE_NAME::TEXT;
                 END IF;
                 linha_auditoria = ROW(
                     NEXTVAL('public.seq_registro_alteracao'),									/*id_registro_alteracao*/
                     (SELECT sta.id_tabela_auditoria FROM public.sis_tabela_auditoria AS sta WHERE TRIM(sta.nome_tabela_auditoria) = TRIM(TG_TABLE_NAME::TEXT)), /*nome_tabela*/
                     SESSION_USER::TEXT,															/*usuario_conexao*/
                     SUBSTRING(CAST(CURRENT_SETTING('petros.conta_usuario') AS TEXT), 1, 50),    /*conta do usuário do PETROS*/
                    CLOCK_TIMESTAMP(),															/*data_registro_alteracao*/
                     SUBSTRING(TG_OP,1,1),														/*acao*/
                     NULL,																		/*registro_original*/
                     NULL,																		/*campos_alterados*/
                     FALSE,																		/*somente_comando*/
                     NULL																		/*chave_primaria*/
                     );
                 IF TG_ARGV[1] IS NOT NULL THEN
                     colunas_excluidas = TG_ARGV[1]::TEXT[];
                     IF (UPPER(TG_ARGV[1])::TEXT = '{NULL}') THEN
                         colunas_excluidas = ARRAY[]::TEXT[];
                     END IF;
                 END IF;
                 
                 IF TG_ARGV[2] IS NOT NULL THEN
                     chave_primaria = TG_ARGV[2]::TEXT[];
                 END IF;
                 
                 IF TG_ARGV[3] IS NOT NULL THEN
                     alias_colunas = TG_ARGV[3]::JSONB;
                 END IF;
                 IF (TG_OP = 'UPDATE' AND TG_LEVEL = 'ROW') THEN         
                     linha_auditoria.campos_alterados =  F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), TO_JSONB(OLD.*)) - colunas_excluidas - chave_primaria;
                     linha_auditoria.registro_original = F_SIS_SUBTRACAO_JSONB(TO_JSONB(OLD.*), F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), linha_auditoria.campos_alterados)) - colunas_excluidas - chave_primaria;
                     linha_auditoria.chave_primaria = F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), (TO_JSONB(NEW.*) - chave_primaria));
                     IF linha_auditoria.campos_alterados = CAST('{}' AS JSONB) THEN
                         RETURN NULL;
                     END IF;
                 ELSIF (TG_OP = 'DELETE' AND TG_LEVEL = 'ROW') THEN
                     linha_auditoria.registro_original = TO_JSONB(OLD.*) - colunas_excluidas - chave_primaria;
                     linha_auditoria.chave_primaria = F_SIS_SUBTRACAO_JSONB(TO_JSONB(OLD.*), (TO_JSONB(OLD.*) - chave_primaria));
                 ELSIF (TG_OP = 'INSERT' AND TG_LEVEL = 'ROW') THEN
                     linha_auditoria.registro_original = TO_JSONB(NEW.*) - colunas_excluidas - chave_primaria;
                     linha_auditoria.chave_primaria = F_SIS_SUBTRACAO_JSONB(TO_JSONB(NEW.*), (TO_JSONB(NEW.*) - chave_primaria));
                 ELSIF (TG_LEVEL = 'STATEMENT' AND TG_OP IN ('INSERT','UPDATE','DELETE','TRUNCATE')) THEN
                     linha_auditoria.somente_comando = TRUE;
                 ELSE
                     RAISE EXCEPTION '[f_sis_auditoria_tabela] - Função adicionada como um trigger para um caso nao tratado: %, %',TG_OP, TG_LEVEL;
                 END IF;
                 
                 linha_auditoria.campos_alterados = (SELECT f_sis_substitui_alias_colunas_auditoria(TG_TABLE_NAME, linha_auditoria.campos_alterados, alias_colunas, 'G'));
                 linha_auditoria.registro_original = (SELECT f_sis_substitui_alias_colunas_auditoria(TG_TABLE_NAME, linha_auditoria.registro_original, alias_colunas, 'G'));
                 linha_auditoria.chave_primaria = (SELECT f_sis_substitui_alias_colunas_auditoria(TG_TABLE_NAME, linha_auditoria.chave_primaria, alias_colunas, 'G'));
                 INSERT INTO public.sis_registro_alteracao VALUES (linha_auditoria.*);
                 RETURN NULL;
             END;
             
            \$BODY\$;";
}


?>
