<?php
// Verificar se a requisição é do tipo POST e se contém o arquivo "evidencia"
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_FILES['evidencia'])) {
    $uploadDir = '../_evidencias/'; // Diretório onde a imagem será salva

    // Verificar se houve algum erro no upload
    if ($_FILES['evidencia']['error'] === UPLOAD_ERR_OK) {
        $tempFile = $_FILES['evidencia']['tmp_name'];
        $originalFileName = $_FILES['evidencia']['name'];

        // Obter a extensão do arquivo original
        $fileExtension = strtolower(pathinfo($originalFileName, PATHINFO_EXTENSION));

        // Gerar um novo nome para o arquivo para evitar conflitos de nomes
        $uniqueFileName = $originalFileName;

        // Caminho completo do arquivo no diretório de destino
        $uploadFile = $uploadDir . $uniqueFileName;

        

        // Mover o arquivo para o diretório de destino
        if (move_uploaded_file($tempFile, $uploadFile)) {
            // Responder com sucesso
            echo json_encode(array('status' => 'success', 'message' => 'Upload realizado com sucesso.', 'filename' => $uniqueFileName));
            exit;
        } else {
            // Responder com erro em caso de falha no upload
            echo json_encode(array('status' => 'error', 'message' => 'Falha ao salvar a imagem no servidor.'));
            exit;
        }
    } else {
        // Responder com erro em caso de falha no upload
        echo json_encode(array('status' => 'error', 'message' => 'Erro durante o upload da imagem.'));
        exit;
    }
} else {
    // Responder com erro se a requisição não contiver o arquivo "evidencia"
    echo json_encode(array('status' => 'error', 'message' => 'Nenhum arquivo foi enviado.'));
    exit;
}
?>
