<?php
session_start();

// Conexão com o banco de dados PostgreSQL
include("../multi_conn.php");

// Verifica se os campos de usuário e senha foram enviados
if (isset($_POST['username']) && isset($_POST['password'])) {
    // Obtém os valores enviados pelo formulário
    $username = $_POST['username'];
    $password = $_POST['password'];

    // Consulta para verificar se o usuário existe no banco de dados
    $query = "SELECT * FROM sis_usuarios WHERE login = $1 AND ativo = 'S'";
    $result = pg_query_params($conn_247, $query, array($username));

    // Verifica se a consulta retornou algum resultado
    if ($row = pg_fetch_assoc($result)) {
        // Verifica se a senha está correta usando password_verify
        if (password_verify($password, $row['senha'])) {
            // Define a variável de sessão para identificar o usuário logado
            $_SESSION['username'] = $username;
            
            // Se a opção "lembrar senha" estiver marcada, define um cookie para armazenar as credenciais
            if (isset($_POST['remember_me']) && $_POST['remember_me'] == 'on') {
                $cookie_name = 'login_cookie';
                $cookie_value = base64_encode($username . ':' . $password);
                setcookie($cookie_name, $cookie_value, time() + (86400 * 30), "/"); // Cookie válido por 30 dias
            }
            
            // Redireciona para a página de sucesso
            header("Location: ../recebimento.php");
            exit();
        } else {
            // Senha incorreta, exibe mensagem de erro
            echo "Erro ao efetuar login: Senha incorreta.";
        }
    } else {
        // Usuário não encontrado, exibe mensagem de erro
        echo "Erro ao efetuar login: Usuário não encontrado.";
    }
} else {
    // Caso os campos não tenham sido enviados, exibe mensagem de erro
    echo "Erro ao efetuar login: Erro ao enviar dados.";
}

// Fecha a conexão com o banco de dados
pg_close($conn_247);
?>